/**
    * @license
    * Copyright 2020 Google LLC. All Rights Reserved.
    * Licensed under the Apache License, Version 2.0 (the "License");
    * you may not use this file except in compliance with the License.
    * You may obtain a copy of the License at
    *
    * http://www.apache.org/licenses/LICENSE-2.0
    *
    * Unless required by applicable law or agreed to in writing, software
    * distributed under the License is distributed on an "AS IS" BASIS,
    * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    * See the License for the specific language governing permissions and
    * limitations under the License.
    * =============================================================================
    */
import{slice,add,div,sub,mul,concat2d,Tensor,concat,tensor1d,tensor2d,tidy,sigmoid,image,browser}from"@tensorflow/tfjs-core";import{loadGraphModel}from"@tensorflow/tfjs-converter";const disposeBox=t=>{t.startEndTensor.dispose(),t.startPoint.dispose(),t.endPoint.dispose()},createBox=t=>({startEndTensor:t,startPoint:slice(t,[0,0],[-1,2]),endPoint:slice(t,[0,2],[-1,2])}),scaleBox=(t,s)=>{const e=mul(t.startPoint,s),o=mul(t.endPoint,s),i=concat2d([e,o],1);return createBox(i)},ANCHORS_CONFIG={strides:[8,16],anchors:[2,6]},NUM_LANDMARKS=6;function generateAnchors(t,s,e){const o=[];for(let i=0;i<e.strides.length;i++){const a=e.strides[i],n=Math.floor((s+a-1)/a),r=Math.floor((t+a-1)/a),c=e.anchors[i];for(let t=0;t<n;t++){const s=a*(t+.5);for(let t=0;t<r;t++){const e=a*(t+.5);for(let t=0;t<c;t++)o.push([e,s])}}}return o}function decodeBounds(t,s,e){const o=slice(t,[0,1],[-1,2]),i=add(o,s),a=slice(t,[0,3],[-1,2]),n=div(a,e),r=div(i,e),c=div(n,2),l=sub(r,c),d=add(r,c),h=mul(l,e),p=mul(d,e);return concat2d([h,p],1)}function getInputTensorDimensions(t){return t instanceof Tensor?[t.shape[0],t.shape[1]]:[t.height,t.width]}function flipFaceHorizontal(t,s){return t.topLeft instanceof Tensor?{topLeft:concat([sub(s-1,t.topLeft.slice(0,1)),t.topLeft.slice(1,1)]),bottomRight:concat([sub(s-1,t.bottomRight.slice(0,1)),t.bottomRight.slice(1,1)]),landmarks:sub(tensor1d([s-1,0]),t.landmarks).mul(tensor1d([1,-1])),probability:t.probability}:{topLeft:[s-1-t.topLeft[0],t.topLeft[1]],bottomRight:[s-1-t.bottomRight[0],t.bottomRight[1]],landmarks:t.landmarks.map(t=>[s-1-t[0],t[1]]),probability:t.probability}}class BlazeFaceModel{constructor(t,s,e,o,i,a){this.blazeFaceModel=t,this.width=s,this.height=e,this.maxFaces=o,this.anchorsData=generateAnchors(s,e,ANCHORS_CONFIG),this.anchors=tensor2d(this.anchorsData),this.inputSizeData=[s,e],this.inputSize=tensor1d([s,e]),this.iouThreshold=i,this.scoreThreshold=a}async getBoundingBoxes(t,s){const[e,o,i]=tidy(()=>{const s=t.resizeBilinear([this.width,this.height]),e=mul(sub(s.div(255),.5),2),o=this.blazeFaceModel.predict(e).squeeze(),i=decodeBounds(o,this.anchors,this.inputSize),a=slice(o,[0,0],[-1,1]);return[o,i,sigmoid(a).squeeze()]}),a=console.warn;console.warn=(()=>{});const n=image.nonMaxSuppression(o,i,this.maxFaces,this.iouThreshold,this.scoreThreshold);console.warn=a;const r=await n.array();n.dispose();let c=r.map(t=>slice(o,[t,0],[1,-1]));s||(c=await Promise.all(c.map(async t=>{const s=await t.array();return t.dispose(),s})));const l=t.shape[1],d=t.shape[2];let h;h=s?div([d,l],this.inputSize):[d/this.inputSizeData[0],l/this.inputSizeData[1]];const p=c.map((t,o)=>tidy(()=>{const a=r[o];let n;return n=s?this.anchors.slice([a,0],[1,2]):this.anchorsData[a],{box:createBox(t instanceof Tensor?t:tensor2d(t)),landmarks:slice(e,[a,NUM_LANDMARKS-1],[1,-1]).squeeze().reshape([NUM_LANDMARKS,-1]),probability:slice(i,[a],[1]),anchor:n}}));return o.dispose(),i.dispose(),e.dispose(),[p,h]}async estimateFaces(t,s=!1,e=!1){const[,o]=getInputTensorDimensions(t),i=tidy(()=>(t instanceof Tensor||(t=browser.fromPixels(t)),t.toFloat().expandDims(0))),[a,n]=await this.getBoundingBoxes(i,s);return i.dispose(),s?a.map(t=>{const s=scaleBox(t.box,n).startEndTensor.squeeze();let i={topLeft:s.slice([0],[2]),bottomRight:s.slice([2],[2]),landmarks:t.landmarks.add(t.anchor).mul(n),probability:t.probability};return e&&(i=flipFaceHorizontal(i,o)),i}):Promise.all(a.map(async t=>{const s=tidy(()=>scaleBox(t.box,n).startEndTensor.squeeze()),[i,a,r]=await Promise.all([t.landmarks,s,t.probability].map(async t=>t.array())),c=t.anchor,l=i.map(t=>[(t[0]+c[0])*n[0],(t[1]+c[1])*n[1]]);s.dispose(),disposeBox(t.box),t.landmarks.dispose(),t.probability.dispose();let d={topLeft:a.slice(0,2),bottomRight:a.slice(2),landmarks:l,probability:r};return e&&(d=flipFaceHorizontal(d,o)),d}))}}const BLAZEFACE_MODEL_URL="https://tfhub.dev/tensorflow/tfjs-model/blazeface/1/default/1";async function load({maxFaces:t=10,inputWidth:s=128,inputHeight:e=128,iouThreshold:o=.3,scoreThreshold:i=.75}={}){const a=await loadGraphModel(BLAZEFACE_MODEL_URL,{fromTFHub:!0});return new BlazeFaceModel(a,s,e,t,o,i)}export{load,BlazeFaceModel};
