/**
    * @license
    * Copyright 2020 Google LLC. All Rights Reserved.
    * Licensed under the Apache License, Version 2.0 (the "License");
    * you may not use this file except in compliance with the License.
    * You may obtain a copy of the License at
    *
    * http://www.apache.org/licenses/LICENSE-2.0
    *
    * Unless required by applicable law or agreed to in writing, software
    * distributed under the License is distributed on an "AS IS" BASIS,
    * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    * See the License for the specific language governing permissions and
    * limitations under the License.
    * =============================================================================
    */
!function(t,e){"object"==typeof exports&&"undefined"!=typeof module?e(exports,require("@tensorflow/tfjs-core"),require("@tensorflow/tfjs-converter")):"function"==typeof define&&define.amd?define(["exports","@tensorflow/tfjs-core","@tensorflow/tfjs-converter"],e):e(t.blazeface={},t.tf,t.tf)}(this,function(t,e,s){"use strict";const o=t=>{t.startEndTensor.dispose(),t.startPoint.dispose(),t.endPoint.dispose()},i=t=>({startEndTensor:t,startPoint:e.slice(t,[0,0],[-1,2]),endPoint:e.slice(t,[0,2],[-1,2])}),n=(t,s)=>{const o=e.mul(t.startPoint,s),n=e.mul(t.endPoint,s),a=e.concat2d([o,n],1);return i(a)},a={strides:[8,16],anchors:[2,6]},r=6;function c(t,s){return t.topLeft instanceof e.Tensor?{topLeft:e.concat([e.sub(s-1,t.topLeft.slice(0,1)),t.topLeft.slice(1,1)]),bottomRight:e.concat([e.sub(s-1,t.bottomRight.slice(0,1)),t.bottomRight.slice(1,1)]),landmarks:e.sub(e.tensor1d([s-1,0]),t.landmarks).mul(e.tensor1d([1,-1])),probability:t.probability}:{topLeft:[s-1-t.topLeft[0],t.topLeft[1]],bottomRight:[s-1-t.bottomRight[0],t.bottomRight[1]],landmarks:t.landmarks.map(t=>[s-1-t[0],t[1]]),probability:t.probability}}class l{constructor(t,s,o,i,n,r){this.blazeFaceModel=t,this.width=s,this.height=o,this.maxFaces=i,this.anchorsData=function(t,e,s){const o=[];for(let i=0;i<s.strides.length;i++){const n=s.strides[i],a=Math.floor((e+n-1)/n),r=Math.floor((t+n-1)/n),c=s.anchors[i];for(let t=0;t<a;t++){const e=n*(t+.5);for(let t=0;t<r;t++){const s=n*(t+.5);for(let t=0;t<c;t++)o.push([s,e])}}}return o}(s,o,a),this.anchors=e.tensor2d(this.anchorsData),this.inputSizeData=[s,o],this.inputSize=e.tensor1d([s,o]),this.iouThreshold=n,this.scoreThreshold=r}async getBoundingBoxes(t,s){const[o,n,a]=e.tidy(()=>{const s=t.resizeBilinear([this.width,this.height]),o=e.mul(e.sub(s.div(255),.5),2),i=this.blazeFaceModel.predict(o).squeeze(),n=function(t,s,o){const i=e.slice(t,[0,1],[-1,2]),n=e.add(i,s),a=e.slice(t,[0,3],[-1,2]),r=e.div(a,o),c=e.div(n,o),l=e.div(r,2),d=e.sub(c,l),h=e.add(c,l),p=e.mul(d,o),u=e.mul(h,o);return e.concat2d([p,u],1)}(i,this.anchors,this.inputSize),a=e.slice(i,[0,0],[-1,1]);return[i,n,e.sigmoid(a).squeeze()]}),c=console.warn;console.warn=(()=>{});const l=e.image.nonMaxSuppression(n,a,this.maxFaces,this.iouThreshold,this.scoreThreshold);console.warn=c;const d=await l.array();l.dispose();let h=d.map(t=>e.slice(n,[t,0],[1,-1]));s||(h=await Promise.all(h.map(async t=>{const e=await t.array();return t.dispose(),e})));const p=t.shape[1],u=t.shape[2];let f;f=s?e.div([u,p],this.inputSize):[u/this.inputSizeData[0],p/this.inputSizeData[1]];const m=h.map((t,n)=>e.tidy(()=>{const c=d[n];let l;return l=s?this.anchors.slice([c,0],[1,2]):this.anchorsData[c],{box:t instanceof e.Tensor?i(t):i(e.tensor2d(t)),landmarks:e.slice(o,[c,r-1],[1,-1]).squeeze().reshape([r,-1]),probability:e.slice(a,[c],[1]),anchor:l}}));return n.dispose(),a.dispose(),o.dispose(),[m,f]}async estimateFaces(t,s=!1,i=!1){const[,a]=function(t){return t instanceof e.Tensor?[t.shape[0],t.shape[1]]:[t.height,t.width]}(t),r=e.tidy(()=>(t instanceof e.Tensor||(t=e.browser.fromPixels(t)),t.toFloat().expandDims(0))),[l,d]=await this.getBoundingBoxes(r,s);return r.dispose(),s?l.map(t=>{const e=n(t.box,d).startEndTensor.squeeze();let s={topLeft:e.slice([0],[2]),bottomRight:e.slice([2],[2]),landmarks:t.landmarks.add(t.anchor).mul(d),probability:t.probability};return i&&(s=c(s,a)),s}):Promise.all(l.map(async t=>{const s=e.tidy(()=>n(t.box,d).startEndTensor.squeeze()),[r,l,h]=await Promise.all([t.landmarks,s,t.probability].map(async t=>t.array())),p=t.anchor,u=r.map(t=>[(t[0]+p[0])*d[0],(t[1]+p[1])*d[1]]);s.dispose(),o(t.box),t.landmarks.dispose(),t.probability.dispose();let f={topLeft:l.slice(0,2),bottomRight:l.slice(2),landmarks:u,probability:h};return i&&(f=c(f,a)),f}))}}const d="https://tfhub.dev/tensorflow/tfjs-model/blazeface/1/default/1";t.load=async function({maxFaces:t=10,inputWidth:e=128,inputHeight:o=128,iouThreshold:i=.3,scoreThreshold:n=.75}={}){const a=await s.loadGraphModel(d,{fromTFHub:!0});return new l(a,e,o,t,i,n)},t.BlazeFaceModel=l,Object.defineProperty(t,"__esModule",{value:!0})});
